/*  Project partsasm
	Project Team DoGA
	Copyright (c) 1995. All Rights Reserved.

	TuVXe:    partsasm.exe Application
	t@C:        pasmapp.cpp
	쐬:          Taka2


	Tv
	====
	partsasmApp (TApplication) ̃Cve[Vp̃\[Xt@C
*/


#include <owl\owlpch.h>
#pragma hdrstop

#include <owl\inputdia.h>
#include <owl\statusba.h>
#include "pasmapp.h"
#include "prtssmad.h"                        // uvOɂāv_CAO{bNX̒`
#include "winframe.h"
#include "design.h"
#include "parts.h"
#include "partsdlg.h"
#include "files.h"
#include "fxg.h"
#include "dslider.h"
#include "dselcol.h"
#include "rendexec.h"
#include "suflib.h"
#include "bmpopen.h"
#include "syscolor.h"
#include "log.h"

//{{partsasmApp Implementation}}

//const char *HelpFileName="partsasm.hlp";
char HelpFileName[256];


//
// AvP[V邷ׂẴbZ[W^R}hɑ΂鉞e[u쐬
//
DEFINE_RESPONSE_TABLE1(partsasmApp, TApplication)
//{{partsasmAppRSP_TBL_BEGIN}}
    EV_COMMAND(CM_FILENEW, CmFileNew),                      EV_COMMAND_ENABLE(CM_FILENEW, CmFileNewEnable),
    EV_COMMAND(CM_FILEOPEN, CmFileOpen),
    EV_COMMAND(CM_FILESAVEAS, CmFileSaveAs),                EV_COMMAND_ENABLE(CM_FILESAVEAS, CmFileSaveAsEnable),
    EV_COMMAND(CM_FILESAVE, CmFileSave),					EV_COMMAND_ENABLE(CM_FILESAVE, CmFileSaveEnable),

	EV_COMMAND(CM_EDITDELETE, CmEditDelete),                EV_COMMAND_ENABLE(CM_EDITDELETE, CmEditDeleteEnable),
	EV_COMMAND(CM_EDITDUP, CmEditDuplicate),				EV_COMMAND_ENABLE(CM_EDITDUP, CmEditDuplicateEnable),
	EV_COMMAND(CM_PartsExchange, CmPartsExchange),          EV_COMMAND_ENABLE(CM_PartsExchange, CmPartsExchangeEnable),
	EV_COMMAND(CM_EDITDUPX, CmEditDuplicateX),              EV_COMMAND_ENABLE(CM_EDITDUPX, CmEditDuplicateEnable),
	EV_COMMAND(CM_EDITDUPY, CmEditDuplicateY),              EV_COMMAND_ENABLE(CM_EDITDUPY, CmEditDuplicateEnable),
	EV_COMMAND(CM_EDITDUPZ, CmEditDuplicateZ),              EV_COMMAND_ENABLE(CM_EDITDUPZ, CmEditDuplicateEnable),
	EV_COMMAND(CM_ALLSCALE, CmAllScale),                    EV_COMMAND_ENABLE(CM_ALLSCALE, CmAllScaleEnable),

	EV_COMMAND(CM_PartsCatalog, CmPartsCatalog),            EV_COMMAND_ENABLE(CM_PartsCatalog, CmPartsCatalogEnable),
	EV_COMMAND(CM_PARTSINITROT, CmPartsInitRot),            EV_COMMAND_ENABLE(CM_PARTSINITROT, CmPartsInitRotEnable),
	EV_COMMAND(CM_PARTSINITSCALE, CmPartsInitScale),        EV_COMMAND_ENABLE(CM_PARTSINITSCALE, CmPartsInitScaleEnable),

	EV_COMMAND(CM_FXGSHOW, CmFxgShow),                      EV_COMMAND_ENABLE(CM_FXGSHOW, CmFxgShowEnable),
	EV_COMMAND(CM_RENDSHOW, CmRendShow),                    EV_COMMAND_ENABLE(CM_RENDSHOW, CmRendShowEnable),
	EV_COMMAND(CM_RENDCOLOR, CmRendColor),                  EV_COMMAND_ENABLE(CM_RENDCOLOR, CmRendColorEnable),

	EV_COMMAND(CM_DISPZOOM, CmDispZoom),				    EV_COMMAND_ENABLE(CM_DISPZOOM, CmDispZoomEnable),
    EV_COMMAND(CM_ETCSCALEDOWN, CmEtcScaleDown),            EV_COMMAND_ENABLE(CM_ETCSCALEDOWN, CmEtcScaleDownEnable),
    EV_COMMAND(CM_ETCSCALEUP, CmEtcScaleUp),                EV_COMMAND_ENABLE(CM_ETCSCALEUP, CmEtcScaleUpEnable),
	EV_COMMAND(CM_ETCMESHON, CmEtcMeshOn),                  EV_COMMAND_ENABLE(CM_ETCMESHON, CmEtcMeshOnEnable),
    EV_COMMAND(CM_ETCMESHSPACING, CmEtcMeshSpacing),        EV_COMMAND_ENABLE(CM_ETCMESHSPACING, CmEtcMeshSpacingEnable),
    EV_COMMAND(CM_ETCINITEYE, CmEtcInitEye),                EV_COMMAND_ENABLE(CM_ETCINITEYE, CmEtcInitEyeEnable),

    EV_COMMAND(CM_ETCHIDDENREMOVE, CmEtcHiddenRemove),		EV_COMMAND_ENABLE(CM_ETCHIDDENREMOVE, CmEtcHiddenRemoveEnable),
    EV_COMMAND(CM_ETCGRID, CmEtcGrid),                      EV_COMMAND_ENABLE(CM_ETCGRID, CmEtcGridEnable),
    EV_COMMAND(CM_ETCGRIDSPACE, CmEtcGridSpace),
    EV_COMMAND(CM_ETCROTSPACE, CmEtcRotSpace),
    EV_COMMAND(CM_ETCSCALESPACE, CmEtcScaleSpace),

    EV_COMMAND(CM_HELPCONTEXT, CmHelpContext),
    EV_COMMAND(CM_HELPABOUT, CmHelpAbout),

    EV_COMMAND(CM_ETCSCALEONLY, CmEtcScaleOnly),
    EV_COMMAND(CM_ETCROTONLY, CmEtcRotOnly),
    EV_COMMAND(CM_ETCROTSCALE, CmEtcRotScaleCompound),
    EV_COMMAND(CM_ETCINITTARGET, CmEtcInitTarget),
    EV_COMMAND(CM_PARTSINITMOVE, CmPartsInitMove),

    EV_COMMAND_ENABLE(CM_ETCROTONLY, CmEtcRotOnlyEnable),
    EV_COMMAND_ENABLE(CM_ETCSCALEONLY, CmEtcScaleOnlyEnable),
    EV_COMMAND_ENABLE(CM_ETCROTSCALE, CmEtcRotScaleCompoundEnable),

    EV_COMMAND_ENABLE(CM_PARTSINITMOVE, CmPartsInitMoveEnable),

	EV_BN_CLICKED(BUTTON_OK, EvButtonOk),
//{{partsasmAppRSP_TBL_END}}
END_RESPONSE_TABLE;




//////////////////////////////////////////////////////////
// partsasmApp
// =====
//
partsasmApp::partsasmApp () : TApplication("Parts Assembler")
{
	HelpState = FALSE;
	execonce = FALSE;
	// uJvƁuOtĕۑv_CAO{bNXɋʂ́Ct@CtOƃtB^Bt@C
	// fBNǵCo[֐ CmFileOpen  CmFileSaveAs ŌvZ
    // INSERT>> RXgN^p̃R[h͂

}


partsasmApp::~partsasmApp ()
{
	// INSERT>> fXgN^p̃R[h͂

}


//////////////////////////////////////////////////////////
// partsasmApp
// =====
// AvP[V̏
//
void partsasmApp::InitMainWindow ()
{
	TWinFrame *client = new TWinFrame(0);

    designdata = client->designdata;

//	TFrameWindow *frame = new TFrameWindow(0, GetName(), client, TRUE);
	TDecoratedFrame *frame = new TDecoratedFrame(0, GetName(), client, TRUE);

	int screenX = GetSystemMetrics(SM_CXSCREEN);
	int screenY = GetSystemMetrics(SM_CYSCREEN);
	if (screenX <= 800) {
		frame->Attr.W = screenX - 20;
		frame->Attr.H = screenY - 60;
	} else {
		frame->Attr.W = 800;
		frame->Attr.H = 600;
	}

	// CEBhEṕCftHg̃EBhEX^CI[o[Ch
	frame->Attr.Style |= WS_BORDER | WS_CAPTION | WS_CLIPCHILDREN | WS_MAXIMIZEBOX | WS_MINIMIZEBOX | WS_SYSMENU | WS_THICKFRAME | WS_VISIBLE;
	frame->Attr.Style &= ~(WS_CHILD);

	nCmdShow = nCmdShow != SW_SHOWMINIMIZED ? SW_SHOWNORMAL : nCmdShow;

	//
	// ̃AvP[VɁCACRݒ肷
	//
	frame->SetIcon(this, IDI_SDIAPPLICATION);

    //
    // EBhEɑΉj[ƁCe[uɑΉANZ[^̃e[u
	//

	frame->AssignMenu(SDI_MENU);

#if 0
	switch (fxgaflag) {
	case PREVIEW_FXGA:
		frame->AssignMenu(SDI_MENU);
		break;
	case PREVIEW_REND:
		frame->AssignMenu(SDI_MENU_REND);
		break;
	case PREVIEW_BOTH:
		frame->AssignMenu(SDI_MENU_BOTH);
		break;
	}
#endif

	//
    // ANZ[^e[uւ̊֘At
    //
    frame->Attr.AccelTable = SDI_MENU;

	frame->Insert(*designdata->InitStatusBar(), TDecoratedFrame::Bottom);

	SetMainWindow(frame);

}


//////////////////////////////////////////////////////////
// partsasmApp
// ===========
// ut@Cvj[́uVK쐬vR}h
void partsasmApp::CmFileNew ()
{
	TWindow *client = TYPESAFE_DOWNCAST(GetMainWindow()->GetClientWindow(), TWindow);     // t[p̃NCAgEBhE
	if (client->CanClose()) {
		designdata->FileNew();
	}
}


//////////////////////////////////////////////////////////
// partsasmApp
// ===========
// ut@Cvj[́uJvR}h
void partsasmApp::CmFileOpen ()
{
    //
	// ẂuJv_CAO{bNX\Ct@CI
    //

#if 0
	TOpenSaveDialog::TData FileData(
							OFN_FILEMUSTEXIST | OFN_HIDEREADONLY,
							"t[t@C(*.fsc)|*.fsc|",
							0, designdata->filedir, "FSC");
	TWindow *client = TYPESAFE_DOWNCAST(GetMainWindow()->GetClientWindow(), TWindow);     // t[p̃NCAgEBhE
	if (client->CanClose()) {
		if (TFileOpenDialog(GetMainWindow(), FileData).Execute() == IDOK) {
			designdata->FileRead(FileData.FileName);
		}
	}
#else
	#ifndef MAX_PATH
		#define MAX_PATH 256
	#endif
	if (GetMainWindow()->CanClose()) {
		char fname[MAX_PATH];
		if (FileOpenDialogWithBMP(
						GetMainWindow(),fname,
							OFN_FILEMUSTEXIST | OFN_HIDEREADONLY,
							"t[t@C(*.fsc)|*.fsc|",
							0, designdata->filedir, "FSC") == IDOK) {
			designdata->FileRead(fname);
		}
	}
#endif
}


//////////////////////////////////////////////////////////
// partsasmApp
// ===========
// uwvvj[́upartsasm.exe ɂāvR}h
void partsasmApp::CmHelpAbout ()
{
    //
    // [__CAO\
    //
	partsasmAboutDlg(MainWindow).Execute();
}


int OwlMain (int /*argc*/, char* /*argv*/[])
{
	partsasmApp     App;
	int             result;

	FileInit();
	sprintf(HelpFileName, "%sPARTSASM.HLP", pathdir.c_str());

	Object::UsePoly();

	result = App.Run();

	return result;
}

void partsasmApp::CmPartsAdd ()
{
	// INSERT>> ǉR[h͂

	TOpenSaveDialog::TData FileData(
							OFN_FILEMUSTEXIST | OFN_HIDEREADONLY,
							"`t@C(*.suf)|*.suf|"
							"ׂẴt@C(*.*)|*.*|",
							0, "", "suf");
	TFileOpenDialog OpenDlg(GetMainWindow(), FileData);
	//
	// ẂuJv_CAO{bNX\Ct@CI
	//
	if (OpenDlg.Execute() == IDOK) {
		designdata->PartsAdd(FileData.FileName,
			-(1.0/designdata->displayscale) * designdata->displayoffset);
	}
}

void partsasmApp::CmPartsCatalog ()
{
	// INSERT>> ǉR[h͂

	PartsDialog dialog(GetMainWindow(), designdata->cataloglastmenu, designdata->cataloglastparts);
	if (dialog.Execute() == IDOK) {
		designdata->PartsAdd(dialog.filename,
			-(1.0/designdata->displayscale) * designdata->displayoffset);
		designdata->cataloglastmenu = dialog.nowmenu;
		designdata->cataloglastparts = dialog.nowparts;
	}
}


void partsasmApp::CmEtcScaleDown ()
{
    // INSERT>> ǉR[h͂
    designdata->ScaleDown();
}


void partsasmApp::CmEtcScaleDownEnable (TCommandEnabler &tce)
{
    // INSERT>> ǉR[h͂
	tce.Enable(designdata->ScaleDownLimitCheck());
}

void partsasmApp::CmEtcScaleUp ()
{
	// INSERT>> ǉR[h͂
	designdata->ScaleUp();
}

void partsasmApp::CmEtcScaleUpEnable (TCommandEnabler &tce)
{
	// INSERT>> ǉR[h͂
	tce.Enable(designdata->ScaleUpLimitCheck());
}

void partsasmApp::CmEditDelete ()
{
	// INSERT>> ǉR[h͂
	designdata->PartsDelete(designdata->select);
}


void partsasmApp::CmEditDuplicate ()
{
    // INSERT>> ǉR[h͂
   	designdata->PartsCopy(designdata->select);
}


void partsasmApp::CmEditDuplicateX ()
{
    // INSERT>> ǉR[h͂
   	designdata->PartsCopy(designdata->select, SelX);
}


void partsasmApp::CmEditDuplicateY ()
{
    // INSERT>> ǉR[h͂
   	designdata->PartsCopy(designdata->select, SelY);
}


void partsasmApp::CmEditDuplicateZ ()
{
    // INSERT>> ǉR[h͂
   	designdata->PartsCopy(designdata->select, SelZ);
}


void partsasmApp::CmFileSaveAs ()
{
    // INSERT>> ǉR[h͂

#if 0
	TOpenSaveDialog::TData FileData(
							OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
							"t[t@C(*.fsc)|*.fsc|",
							0, designdata->filedir, "FSC");

	if (TFileSaveDialog(GetMainWindow(), FileData).Execute() == IDOK) {
		designdata->FileWrite(FileData.FileName);
	}
#else
	char fname[MAX_PATH];
	if (FileSaveDialogWithBMP(
				GetMainWindow(), fname,
				OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
				"t[t@C(*.fsc)|*.fsc|",
				0, designdata->filedir, "FSC") == IDOK) {
		designdata->FileWrite(fname);
	}
#endif

}


void partsasmApp::CmFileSave ()
{
	// INSERT>> ǉR[h͂

   	designdata->FileWrite();
}


void partsasmApp::CmFileSaveEnable (TCommandEnabler &tce)
{
    // INSERT>> ǉR[h͂

    tce.Enable(designdata->filename[0] != '\0');
}

void partsasmApp::CmEtcScaleOnly ()
{
    // INSERT>> ǉR[h͂

    designdata->dragtype = DragScaleOnly;
    if (designdata->select != NULL) {
    	designdata->Redraw();
    }
}

void partsasmApp::CmEtcScaleOnlyEnable (TCommandEnabler &tce)
{
    // INSERT>> ǉR[h͂
    if (designdata->dragtype == DragScaleOnly) {
    	tce.SetCheck(1);
    } else {
    	tce.SetCheck(0);
    }
}

void partsasmApp::CmEtcRotOnly ()
{
    // INSERT>> ǉR[h͂

    designdata->dragtype = DragRotOnly;
    if (designdata->select != NULL) {
    	designdata->Redraw();
    }
}

void partsasmApp::CmEtcRotOnlyEnable (TCommandEnabler &tce)
{
    // INSERT>> ǉR[h͂

    if (designdata->dragtype == DragRotOnly) {
    	tce.SetCheck(1);
    } else {
		tce.SetCheck(0);
    }
}


void partsasmApp::CmEtcRotScaleCompound ()
{
    // INSERT>> ǉR[h͂

    designdata->dragtype = DragCompound;
    if (designdata->select != NULL) {
    	designdata->Redraw();
    }
}

void partsasmApp::CmEtcRotScaleCompoundEnable (TCommandEnabler &tce)
{
    // INSERT>> ǉR[h͂

    if (designdata->dragtype == DragCompound) {
    	tce.SetCheck(1);
    } else {
    	tce.SetCheck(0);
    }
}



void partsasmApp::CmEditDuplicateEnable (TCommandEnabler &tce)
{
    // INSERT>> ǉR[h͂
	tce.Enable(designdata->select != NULL
     && designdata->select != designdata->camera
     && designdata->zoommode != ZoomSelect);
}


void partsasmApp::CmEditDeleteEnable (TCommandEnabler &tce)
{
    // INSERT>> ǉR[h͂
	tce.Enable(designdata->select != NULL && designdata->select != designdata->camera && designdata->zoommode != ZoomSelect);
}

void partsasmApp::CmEtcGridSpace ()
{
	// INSERT>> ǉR[h͂


	char *buf[] = {"20", "50", "100", "200", "250", "300", "400", "500",NULL};
	int pos;
	for (pos = 0; buf[pos] != NULL; pos++) {
		if (designdata->gridspacing == atoi(buf[pos])) {
			break;
		}
	}
	if (buf[pos] == NULL) pos = 1;
	TDSliderInput dialog(MainWindow, "ړObhʐݒ", "ʒuݒ̍ŏPʂݒ肵Ă", buf, pos);
	if (dialog.Execute() == IDOK) {
		designdata->gridspacing = atoi(buf[pos]);
	}

#if 0
	char str[16];
	sprintf(str, "%d", designdata->gridspacing);
	TInputDialog dialog(MainWindow, "ړObhʐݒ", "ʒuݒ̍ŏPʂ͂Ă", str, 16);
	if (dialog.Execute() == IDOK) {
		int n = atoi(str);
		if (0 < n && n < 1000) {
			designdata->gridspacing = n;
			designdata->Redraw(SelXYZ, TRUE);
		}
	}
#endif
}


void partsasmApp::CmEtcRotSpace ()
{
	// INSERT>> ǉR[h͂

	char *buf[] = {"2", "5", "10", "15", "20", "30", "45",NULL};
	int pos;
	for (pos = 0; buf[pos] != NULL; pos++) {
		if (designdata->rotspacing == atoi(buf[pos])) {
			break;
		}
	}
	if (buf[pos] == NULL) pos = 5;
	TDSliderInput dialog(MainWindow, "]Obhʐݒ", "]px̍ŏPʂݒ肵Ă", buf, pos);
	if (dialog.Execute() == IDOK) {
		designdata->rotspacing = atoi(buf[pos]);
	}

#if 0
	char str[16];
	sprintf(str, "%d", designdata->rotspacing);
	TInputDialog dialog(MainWindow, "]Obhʐݒ", "]px̍ŏPʂ͂Ă", str, 16);
	if (dialog.Execute() == IDOK) {
		int n = atoi(str);
		if (0 < n && n < 1000) {
			designdata->rotspacing = n;
		}
	}
#endif
}


void partsasmApp::CmEtcScaleSpace ()
{
	// INSERT>> ǉR[h͂

	char *buf[] = {"0.05", "0.1", "0.2", "0.5", NULL};
	int pos;
	for (pos = 0; buf[pos] != NULL; pos++) {
		if (designdata->scalespacing == (int)(atof(buf[pos]) * scalespacingfactor)) {
			break;
		}
	}
	if (buf[pos] == NULL) pos = 3;
	TDSliderInput dialog(MainWindow, "gObhʐݒ", "g{̍ŏPʂݒ肵Ă", buf, pos);
	if (dialog.Execute() == IDOK) {
		designdata->scalespacing = atof(buf[pos]) * scalespacingfactor;
	}

#if 0
	char str[16];
	sprintf(str, "%5.2lf", designdata->scalespacing / scalespacingfactor);
	TInputDialog dialog(MainWindow, "gObhʐݒ", "g{̍ŏPʂ͂Ă", str, 16);
	if (dialog.Execute() == IDOK) {
		double d;
		sscanf(str, "%lf", &d);
		int n = d * scalespacingfactor;
		if (0 < n && n < 10000) {
			designdata->scalespacing = n;
		}
	}
#endif
}


void partsasmApp::CmEtcInitEye ()
{
	// INSERT>> ǉR[h͂
	designdata->camera->position = Vector(1200,-900,900);
//	designdata->camera->SetTarget(designdata->camera->target);
	designdata->camera->SetTarget(Vector(0,0,0));
	designdata->CalcPoints(designdata->camera);
	designdata->CalcViewAll();
	designdata->editflag++;
	designdata->Redraw();

}


void partsasmApp::CmEtcInitTarget ()
{
	// INSERT>> ǉR[h͂
	designdata->camera->SetTarget(Vector(0,0,0));
	designdata->CalcPoints(designdata->camera);
	designdata->CalcViewAll();
	designdata->editflag++;
	designdata->Redraw();

}


void partsasmApp::CmPartsExchange ()
{
	// INSERT>> ǉR[h͂
	PartsDialog dialog(GetMainWindow(), designdata->cataloglastmenu, designdata->cataloglastparts);
	if (dialog.Execute() == IDOK) {
		Vector p = designdata->select->position;
		Vector r = designdata->select->rotation;
		Vector s = designdata->select->scale;
		designdata->PartsDelete(designdata->select);
		designdata->PartsAdd(dialog.filename, p, r, s);
		designdata->cataloglastmenu = dialog.nowmenu;
		designdata->cataloglastparts = dialog.nowparts;
	}
}


void partsasmApp::CmPartsExchangeEnable (TCommandEnabler &tce)
{
	// INSERT>> ǉR[h͂
	tce.Enable(designdata->select != NULL && designdata->select != designdata->camera && designdata->zoommode != ZoomSelect);

}

void partsasmApp::CmEtcHiddenRemove ()
{
    // INSERT>> ǉR[h͂
	designdata->hiddenremove = ! designdata->hiddenremove;
   	designdata->BuildWireFrame();
	designdata->Redraw(SelPers);
}


void partsasmApp::CmEtcHiddenRemoveEnable (TCommandEnabler &tce)
{
    // INSERT>> ǉR[h͂
	tce.SetCheck(designdata->hiddenremove);
}

void partsasmApp::CmEtcGrid ()
{
	// INSERT>> ǉR[h͂
	designdata->gridflag = ! designdata->gridflag;
	designdata->Redraw(SelStat);
}


void partsasmApp::CmEtcGridEnable (TCommandEnabler &tce)
{
    // INSERT>> ǉR[h͂

   if (designdata->gridflag) {
		tce.SetCheck(1);
	} else {
		tce.SetCheck(0);
	}
//    tce.Enable(designdata->zoommode != ZoomSelect);
}


void partsasmApp::CmPartsInitMove ()
{
    // INSERT>> ǉR[h͂

   	designdata->select->position = Vector(0,0,0);
	designdata->CalcPoints(designdata->select);
	designdata->editflag++;
	designdata->Redraw();
}


void partsasmApp::CmPartsInitMoveEnable (TCommandEnabler &tce)
{
    // INSERT>> ǉR[h͂

	tce.Enable(designdata->select != NULL && designdata->select != designdata->camera);
}


void partsasmApp::CmPartsInitRot ()
{
    // INSERT>> ǉR[h͂

   	designdata->select->rotation = Vector(0,0,0);
	designdata->CalcPoints(designdata->select);
	designdata->editflag++;
	designdata->Redraw();
}


void partsasmApp::CmPartsInitRotEnable (TCommandEnabler &tce)
{
    // INSERT>> ǉR[h͂

	tce.Enable(designdata->select != NULL && designdata->select != designdata->camera && designdata->zoommode != ZoomSelect);
}


void partsasmApp::CmPartsInitScale ()
{
    // INSERT>> ǉR[h͂

   	designdata->select->scale = Vector(1,1,1);
	designdata->CalcPoints(designdata->select);
	designdata->editflag++;
	designdata->Redraw();
}


void partsasmApp::CmPartsInitScaleEnable (TCommandEnabler &tce)
{
	// INSERT>> ǉR[h͂

	tce.Enable(designdata->select != NULL && designdata->select != designdata->camera && designdata->zoommode != ZoomSelect);
}


void partsasmApp::CmFxgShow ()
{
	static char *title		="FXGA JfUC\";
	if (FindWindow(NULL, title) != NULL) {
		GetMainWindow()->MessageBox("ݎsł", title, MB_OK);
	} else {
		FXG_Show(designdata->parts);
		designdata->statusbar->SetText("SELECT:CӁE]Ei I:FύX II:\ III:k IV:g V:XyL[ VI:wi\");
	}
}

void partsasmApp::CmFxgShowEnable (TCommandEnabler &tce)
{
	tce.Enable(designdata->parts != NULL && designdata->zoommode != ZoomSelect);
}

void partsasmApp::CmRendShow ()
{
	static char *title = "REND for Windows";
	HWND hRend;
	if (designdata->camera->position.x != designdata->camera->target.x
	 || designdata->camera->position.y != designdata->camera->target.y) {
		if ((hRend = FindWindow(NULL, title)) != NULL) {
			::SendMessage(hRend, WM_CLOSE, 0, 0);
		}
		RendMechanic(designdata->parts, designdata->camera, designdata->color);
	}
}

void partsasmApp::CmRendShowEnable (TCommandEnabler &tce)
{
	tce.Enable(designdata->parts != NULL
	 && designdata->zoommode != ZoomSelect
	 && (designdata->camera->position.x != designdata->camera->target.x
	  || designdata->camera->position.y != designdata->camera->target.y));
}

void partsasmApp::CmRendColor ()
{
	char opt[1024], *s, *d;
	int w=320, h=240;
	strcpy(opt, rendoption.c_str());
	for (s = d = opt; *s; ) {
		if ((*s == '-' || *s == '/') && (s[1] == 'c' || s[1] == 'C')) {
			s+=2;
			w = atoi(s);
			while (*s && isdigit(*s)) s++;
			if (*s) {
				s++;
				if (isdigit(*s)) {
					h = atoi(s);
				}
				while(*s && !isspace(*s)) s++;
				if (*s) s++;
			}
		} else {
			*d++ = *s++;
		}
	}
	while (d > opt  && isspace(d[-1])) d--;
	*d = '\0';
	LightType lt;
	int ilt = 0;
	lt = Parts::GetLightType();
	if (lt == LightRightUpper || lt == LightRightLower) {
		ilt = 1;
	}
	TDSelColor dialog(MainWindow, designdata->color, ilt, w, h);
	if (dialog.Execute() == IDOK) {
		if (designdata->color != (RendColor)dialog.selcolor) {
			designdata->color = (RendColor)dialog.selcolor;
			char *cname[5] = {"","","","",""};
			rendcolor = cname[dialog.selcolor];
		}
		Parts::SetLightType(dialog.sellight ? LightRightUpper : LightLeftUpper);
		rendlight = dialog.sellight ? "E" : "";
		if (w != dialog.selwidth || h != dialog.selheight) {
			w = dialog.selwidth;
			h = dialog.selheight;
			sprintf(opt+strlen(opt), " -c%d:%d:%d:%d", w, h, w, h);
			rendoption = opt;
		}
		FileWriteRendOption();
	}
}

void partsasmApp::CmRendColorEnable (TCommandEnabler &tce)
{
    tce.Enable(designdata->zoommode != ZoomSelect);
}


void partsasmApp::EvButtonOk(void)
{
//	logprintf("ButtonOk\n");
}


void partsasmApp::CmEtcMeshOn ()
{
	// INSERT>> ǉR[h͂

	designdata->meshflag = !designdata->meshflag;
	designdata->Redraw(SelXYZ);
}


void partsasmApp::CmEtcMeshOnEnable (TCommandEnabler &tce)
{
    // INSERT>> ǉR[h͂
	tce.SetCheck(designdata->meshflag != FALSE);
    tce.Enable(designdata->zoommode != ZoomSelect);
}


void partsasmApp::CmEtcMeshSpacing ()
{
    // INSERT>> ǉR[h͂

	char *buf[] = {"50", "100", "200", "250", "300", "400", "500", NULL};
	int pos;
	for (pos = 0; buf[pos] != NULL; pos++) {
		if (designdata->meshspacing == atoi(buf[pos])) {
			break;
		}
	}
	if (buf[pos] == NULL) pos = 5;
	TDSliderInput dialog(MainWindow, "bVԊuݒ", "bV̊Ԋuݒ肵Ă", buf, pos);
	if (dialog.Execute() == IDOK) {
		designdata->meshspacing = atoi(buf[pos]);
		designdata->Redraw(SelXYZ, TRUE);
	}


#if 0
	char str[16];
	sprintf(str, "%d", designdata->meshspacing);
	TInputDialog dialog(MainWindow, "bVԊuݒ", "bV̊Ԋu͂Ă", str, 16);
	if (dialog.Execute() == IDOK) {
		int n = atoi(str);
		if (0 < n && n < 10000) {
			designdata->meshspacing = n;
			designdata->Redraw(SelXYZ, TRUE);
		}
	}
#endif

}


void partsasmApp::CmEtcMeshSpacingEnable (TCommandEnabler &tce)
{
    tce.Enable(designdata->zoommode != ZoomSelect);
}


void partsasmApp::CmAllScale ()
{
    // INSERT>> ǉR[h͂

	char *buf[] = {"0.5", "0.6", "0.7", "0.8", "0.9", "1.0",  "1.1", "1.2", "1.3", "1.4", "1.5", NULL};
	int pos = 5;
	TDSliderInput dialog(MainWindow,"̑S̊g", "̑Ŝ̊g{ݒ肵Ă", buf, pos);
	if (dialog.Execute() == IDOK) {
		double r = atof(buf[pos]);
		designdata->TotalScaling(r);
	}
}


void partsasmApp::CmAllScaleEnable (TCommandEnabler &tce)
{
    // INSERT>> ǉR[h͂

    tce.Enable(designdata->parts != NULL && designdata->zoommode != ZoomSelect);
}


void partsasmApp::CmHelpContext ()
{
	HelpState = GetMainWindow()->WinHelp(HelpFileName, HELP_CONTENTS, 0L);
}


void partsasmApp::CmFileSaveAsEnable (TCommandEnabler &tce)
{
    // INSERT>> ǉR[h͂
	tce.Enable(designdata->parts != NULL);
}


void partsasmApp::CmFileNewEnable (TCommandEnabler &tce)
{
    // INSERT>> ǉR[h͂
	tce.Enable(designdata->parts != NULL);
}


void partsasmApp::CmDispZoom ()
{
    // INSERT>> ǉR[h͂

    designdata->SelectZoom();

}


void partsasmApp::CmDispZoomEnable (TCommandEnabler &tce)
{
    // INSERT>> ǉR[h͂

    tce.SetCheck(designdata->zoommode != ZoomNone);
}



void partsasmApp::CmPartsCatalogEnable (TCommandEnabler &tce)
{
    // INSERT>> ǉR[h͂

    tce.Enable(designdata->zoommode != ZoomSelect);
}


void partsasmApp::CmEtcInitEyeEnable (TCommandEnabler &tce)
{
    // INSERT>> ǉR[h͂
    tce.Enable(designdata->zoommode != ZoomSelect);
}


BOOL partsasmApp::CanClose ()
{
    BOOL result = TApplication::CanClose();

    if (result && HelpState)
	       GetMainWindow()->WinHelp(HelpFileName, HELP_QUIT, 0L);

	static char *title = "REND for Windows";
	HWND hRend;
	if ((hRend = FindWindow(NULL, title)) != NULL) {
		::SendMessage(hRend, WM_CLOSE, 0, 0);
	}

	return result;
}


BOOL partsasmApp::IdleAction (long idleCount)
{
    BOOL result;

    result = TApplication::IdleAction(idleCount);

    // INSERT>> ǉ̃R[h͂

	if (execonce != FALSE) {
		return result;
	}
	execonce = TRUE;

	TWindow *client = GetMainWindow();
	TClientDC dc(*client);
	InitSysColor(dc);

	TMenu menu(GetMainWindow()->GetMenu());
	TMenu submenu(menu.GetSubMenu(3));
	if (fxgaflag == PREVIEW_FXGA) {
		submenu.RemoveMenu(CM_RENDSHOW, MF_BYCOMMAND);
		submenu.RemoveMenu(CM_RENDCOLOR, MF_BYCOMMAND);
	} else if (fxgaflag == PREVIEW_REND) {
		submenu.RemoveMenu(CM_FXGSHOW, MF_BYCOMMAND);
	}

    return result;
}


